"""
Copyright 2008-2014 by Aerospike, Inc. All rights reserved.
THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE
ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
"""


# -*- coding: utf-8 -*-
from helpers import convertor


def set_node_config(cluster_obj, node_list, edit_parameters, user=None, password=None):

    response = dict()
    node_list = convertor.text_to_list(node_list, ',')
    for node_address in node_list:
        node_obj = cluster_obj.get_node(node_address)
        node_response = {'node_status': 'on'}
        if node_obj is None or node_obj.get_status(user=user, password=password) == 'off' or not node_obj.is_valid():
            node_response['node_status'] = 'off'
        else:
            node_response['unset_parameters'] = node_obj.set_configurations(edit_parameters, user=user, password=password)
        response[node_address] = node_response
    return response


def set_namespace_config(cluster_obj, namespace_name, node_list, edit_parameters, user=None, password=None):

    response = dict()
    node_list = convertor.text_to_list(node_list, ',')
    for node_address in node_list:
        node_obj = cluster_obj.get_node(node_address)
        node_response = {'node_status': 'on', 'namespace_status': 'on'}
        if node_obj is None or node_obj.get_status(user=user, password=password) == 'off' or not node_obj.is_valid():
            node_response['node_status'] = 'off'
            node_response['namespace_status'] = 'off'
        else:
            ns_obj = cluster_obj.get_namespace(namespace_name, node_address) # get corresponding Namespace object
            if ns_obj is None:
                node_response['namespace_status'] = 'off'
            else:
                node_response['unset_parameters'] = ns_obj.set_configurations(edit_parameters, user=user, password=password, node=node_obj)
        response[node_address] = node_response
    return response


def set_xdr_config(cluster_obj, node_list, xdr_port, edit_parameters, user=None, password=None):

    response = dict()
    node_list = convertor.text_to_list(node_list, ',')
    for node_address in node_list:
        node_response = {'node_status': 'on', 'xdr_status': 'on'}
        xdr_obj = cluster_obj.get_xdr(xdr_port, node_address,
                                        user=user, password=password)
        if xdr_obj is None:
            node_response['node_status'] = 'off'
            node_response['xdr_status'] = 'off'
        elif xdr_obj == {}:
            node_response['xdr_status'] = "off"
        else:
            node_response['unset_parameters'] = xdr_obj.set_configurations(edit_parameters, user=user, password=password)
        response[node_address] = node_response
    return response

